---------------------
PatchSet 950 
Date: 2000/12/17 14:36:23
Author: hno
Branch: raid
Tag: (none) 
Log:
Imported raid from squidng

Members: 
	acconfig.h:1.4.6.1.2.1->1.4.6.1.2.1.2.1 
	configure.in:1.7.6.1.2.1->1.7.6.1.2.1.2.1 
	doc/debug-sections.txt:1.2.22.1.2.1->1.2.22.1.2.1.2.1 
	src/Makefile.in:1.3.22.1->1.3.22.1.2.1 
	src/cache_cf.c:1.6.4.1->1.6.4.1.6.1 
	src/cf.data.pre:1.5->1.5.12.1 
	src/client_side.c:1.10.2.1.4.1->1.10.2.1.4.1.2.1 
	src/comm.c:1.4.14.1.4.1->1.4.14.1.4.1.2.1 
	src/comm_cio.c:1.1.2.1->1.1.2.1.2.1 
	src/defines.h:1.3.16.1.2.1->1.3.16.1.2.1.4.1 
	src/disk.c:1.4.20.1->1.4.20.1.2.1 
	src/enums.h:1.6.4.1.2.1->1.6.4.1.2.1.4.1 
	src/fd.c:1.4.10.1->1.4.10.1.2.1 
	src/ftp.c:1.5.10.1.4.1->1.5.10.1.4.1.2.1 
	src/gopher.c:1.5.4.1.4.1->1.5.4.1.4.1.2.1 
	src/http.c:1.5.10.1.4.1->1.5.10.1.4.1.2.1 
	src/main.c:1.6.4.1.4.1->1.6.4.1.4.1.2.1 
	src/protos.h:1.6.4.1.2.1.2.1->1.6.4.1.2.1.2.1.2.1 
	src/pump.c:1.4.14.1.4.1->1.4.14.1.4.1.2.1 
	src/raid.c:1.1->1.1.2.1 
	src/squid.h:1.3.16.1.2.1.2.1->1.3.16.1.2.1.2.1.2.1 
	src/ssl.c:1.3.16.1.4.1->1.3.16.1.4.1.2.1 
	src/store.c:1.6.4.1.2.1->1.6.4.1.2.1.4.1 
	src/store_dir.c:1.4.18.1->1.4.18.1.4.1 
	src/store_io.c:1.2->1.2.26.1 
	src/store_swapout.c:1.4.14.1.2.1->1.4.14.1.2.1.4.1 
	src/structs.h:1.8.8.1.2.1->1.8.8.1.2.1.2.1 
	src/typedefs.h:1.4.10.1.2.1.2.1->1.4.10.1.2.1.2.1.2.1 
	src/wais.c:1.3.16.1.4.1->1.3.16.1.4.1.2.1 
	src/whois.c:1.3.16.1.4.1->1.3.16.1.4.1.2.1 
	src/fs/butterfly/store_dir_bf.c:1.1.2.1.2.1->1.1.2.1.2.1.2.1 
	src/fs/butterfly/store_io_bf.c:1.1.2.1->1.1.2.1.4.1 
	src/fs/ufs/store_dir_ufs.c:1.5.4.1->1.5.4.1.6.1 

Index: squid/acconfig.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/Attic/acconfig.h,v
retrieving revision 1.4.6.1.2.1
retrieving revision 1.4.6.1.2.1.2.1
diff -u -r1.4.6.1.2.1 -r1.4.6.1.2.1.2.1
--- squid/acconfig.h	17 Dec 2000 14:09:08 -0000	1.4.6.1.2.1
+++ squid/acconfig.h	17 Dec 2000 14:36:23 -0000	1.4.6.1.2.1.2.1
@@ -20,7 +20,7 @@
  *
  */
 @ TOP @
-/* $Id: acconfig.h,v 1.4.6.1.2.1 2000/12/17 14:09:08 hno Exp $ */
+/* $Id: acconfig.h,v 1.4.6.1.2.1.2.1 2000/12/17 14:36:23 hno Exp $ */
 
 /*********************************
  * START OF CONFIGURABLE OPTIONS *
@@ -286,10 +286,16 @@
 /* Signal driven async network IO */
 #undef TCP_ASYNC
 
+/* Signal handling from signal handlers */
+#undef CIOCIOSAN_USE_SIGHANDLER
+
 /* Periodically dump profile snapshots from running squid */
 #undef PROFILE_SQUID
 #undef PROFIL_DELAY
 
+/* Enable on-fly drive replacement */
+#undef DISK_REPL
+
 /*
  * Define this if unlinkd is required
  * (strongly recommended for ufs storage type)
Index: squid/configure.in
===================================================================
RCS file: /cvsroot/squid-sf//squid/configure.in,v
retrieving revision 1.7.6.1.2.1
retrieving revision 1.7.6.1.2.1.2.1
diff -u -r1.7.6.1.2.1 -r1.7.6.1.2.1.2.1
--- squid/configure.in	17 Dec 2000 14:09:08 -0000	1.7.6.1.2.1
+++ squid/configure.in	17 Dec 2000 14:36:23 -0000	1.7.6.1.2.1.2.1
@@ -3,13 +3,13 @@
 dnl
 dnl  Duane Wessels, wessels@nlanr.net, February 1996 (autoconf v2.9)
 dnl
-dnl  $Id: configure.in,v 1.7.6.1.2.1 2000/12/17 14:09:08 hno Exp $
+dnl  $Id: configure.in,v 1.7.6.1.2.1.2.1 2000/12/17 14:36:23 hno Exp $
 dnl
 dnl
 dnl
 AC_INIT(src/main.c)
 AC_CONFIG_HEADER(include/autoconf.h)
-AC_REVISION($Revision: 1.7.6.1.2.1 $)dnl
+AC_REVISION($Revision: 1.7.6.1.2.1.2.1 $)dnl
 AC_PREFIX_DEFAULT(/usr/local/squid)
 AC_CONFIG_AUX_DIR(cfgaux)
 
@@ -754,6 +754,15 @@
   fi
 ])
 
+dnl Enable signal handling from signal handlers
+AC_ARG_ENABLE(ciociosan-handlers,
+[  --enable-ciociosan-handlers      Enable signal handling from signal handlers (requires ciociosan)],
+[ if test "$enableval" = "yes" ; then
+    echo "Enabling signal handling from signal handlers"
+    AC_DEFINE(CIOCIOSAN_USE_SIGHANDLER)
+  fi
+])
+
 dnl Enable gmon-based profiling
 AC_ARG_ENABLE(profiling,
 [  --enable-profiling      Enable gmon-based profiling],
@@ -784,6 +793,15 @@
 echo "Profiling snapshot dumping interval is set to " $PROFILE_DELAY
 AC_DEFINE_UNQUOTED(PROFIL_DELAY,$PROFILE_DELAY)
 
+dnl Enable on-fly drive replacement
+AC_ARG_ENABLE(disk-repl,
+[  --enable-disk-repl      Enable on-fly drive replacement],
+[ if test "$enableval" = "yes" ; then
+    echo "Enable on-fly drive replacement"
+    AC_DEFINE(DISK_REPL)
+  fi
+])
+
 # Force some compilers to use ANSI features
 #
 case "$host" in
Index: squid/src/cache_cf.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cache_cf.c,v
retrieving revision 1.6.4.1
retrieving revision 1.6.4.1.6.1
diff -u -r1.6.4.1 -r1.6.4.1.6.1
--- squid/src/cache_cf.c	17 Dec 2000 08:20:04 -0000	1.6.4.1
+++ squid/src/cache_cf.c	17 Dec 2000 14:36:23 -0000	1.6.4.1.6.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: cache_cf.c,v 1.6.4.1 2000/12/17 08:20:04 hno Exp $
+ * $Id: cache_cf.c,v 1.6.4.1.6.1 2000/12/17 14:36:23 hno Exp $
  *
  * DEBUG: section 3     Configuration File Parsing
  * AUTHOR: Harvest Derived
@@ -199,7 +199,7 @@
     int i;
     ssize_t ms = -1;
 
-    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
+    FOREACHSDINDEX(i) {
 	if (Config.cacheSwap.swapDirs[i].max_objsize > ms)
 	    ms = Config.cacheSwap.swapDirs[i].max_objsize;
     }
@@ -968,6 +968,7 @@
     swap->swapDirs = NULL;
     swap->n_allocated = 0;
     swap->n_configured = 0;
+    swap->n_offline = 0;
 }
 
 const char *
Index: squid/src/cf.data.pre
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cf.data.pre,v
retrieving revision 1.5
retrieving revision 1.5.12.1
diff -u -r1.5 -r1.5.12.1
--- squid/src/cf.data.pre	12 Dec 2000 23:21:17 -0000	1.5
+++ squid/src/cf.data.pre	17 Dec 2000 14:36:23 -0000	1.5.12.1
@@ -1,6 +1,6 @@
 
 #
-# $Id: cf.data.pre,v 1.5 2000/12/12 23:21:17 adri Exp $
+# $Id: cf.data.pre,v 1.5.12.1 2000/12/17 14:36:23 hno Exp $
 #
 #
 # SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -3306,5 +3306,40 @@
 	force fresh content.
 DOC_END
 
+NAME: watch_failure
+IFDEF: DISK_REPL
+TYPE: wordlist
+LOC: Config.disk_repl_watch_list
+DEFAULT: none
+DOC_START
+	List of the form 
+    <device_file> <cache_dir> <device_file> <cache_dir> ...
+	when device_file fails, cache_dir goes offline.
+DOC_END
+
+NAME: offline_notify_cmd
+IFDEF: DISK_REPL
+TYPE: string
+LOC: Config.offline_notify_cmd
+DEFAULT: none
+DOC_START
+	Command to be executed when some cache_dir goes 
+	offline. This command will be executed with tree parameters:
+	path to the cache_dir, cache_dir index and device file on which dir 
+	is mounted.
+DOC_END
+
+NAME: online_notify_cmd
+IFDEF: DISK_REPL
+TYPE: string
+LOC: Config.online_notify_cmd
+DEFAULT: none
+DOC_START
+	Command to be executed when some cache_dir goes back
+	online. This command will be executed with tree parameters:
+	path to the cache_dir, cache_dir index and device file on which dir 
+	is mounted.
+DOC_END
+
 EOF
 
Index: squid/src/client_side.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/client_side.c,v
retrieving revision 1.10.2.1.4.1
retrieving revision 1.10.2.1.4.1.2.1
diff -u -r1.10.2.1.4.1 -r1.10.2.1.4.1.2.1
--- squid/src/client_side.c	17 Dec 2000 14:09:08 -0000	1.10.2.1.4.1
+++ squid/src/client_side.c	17 Dec 2000 14:36:23 -0000	1.10.2.1.4.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: client_side.c,v 1.10.2.1.4.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: client_side.c,v 1.10.2.1.4.1.2.1 2000/12/17 14:36:23 hno Exp $
  *
  * DEBUG: section 33    Client-side Routines
  * AUTHOR: Duane Wessels
@@ -2530,11 +2530,10 @@
     int len = conn->in.size - conn->in.offset - 1;
     debug(33, 4) ("clientReadRequest: FD %d: reading request...\n", fd);
     statCounter.syscalls.sock.reads++;
-    size = read(fd, conn->in.buf + conn->in.offset, len);
+    size = comm_read_wrapper(fd, conn->in.buf + conn->in.offset, len);
     if (size > 0) {
 	fd_bytes(fd, size, FD_READ);
 	kb_incr(&statCounter.client_http.kbytes_in, size);
-	CLEAR_CAN_READ_IF_EMPTY( len, size, fd );
     }
     /*
      * Don't reset the timeout value here.  The timeout value will be
@@ -2567,7 +2566,6 @@
 	    comm_close(fd);
 	    return;
 	} else {
-	  CLEAR_CAN_READ( fd );
 	  if (conn->in.offset == 0) {
 	    debug(50, 2) ("clientReadRequest: FD %d: no data to process (%s)\n", fd, xstrerror());
 	    return;
Index: squid/src/comm.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/comm.c,v
retrieving revision 1.4.14.1.4.1
retrieving revision 1.4.14.1.4.1.2.1
diff -u -r1.4.14.1.4.1 -r1.4.14.1.4.1.2.1
--- squid/src/comm.c	17 Dec 2000 14:09:08 -0000	1.4.14.1.4.1
+++ squid/src/comm.c	17 Dec 2000 14:36:23 -0000	1.4.14.1.4.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: comm.c,v 1.4.14.1.4.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: comm.c,v 1.4.14.1.4.1.2.1 2000/12/17 14:36:23 hno Exp $
  *
  * DEBUG: section 5     Socket Functions
  * AUTHOR: Harvest Derived
@@ -73,6 +73,7 @@
 static int commResetFD(ConnectStateData * cs);
 static int commRetryConnect(ConnectStateData * cs);
 CBDATA_TYPE(ConnectStateData);
+static SyscallCBInvoc syscallCallback[ SYSCALL_MAX ][ MAX_SYSCALLCB ];
 
 static MemPool *comm_write_pool = NULL;
 static MemPool *conn_close_pool = NULL;
@@ -832,13 +833,18 @@
       fd_table[ fd ].flags.async_tcp = 1;
       fd_table[ fd ].flags.can_read = 1;
       fd_table[ fd ].flags.can_write = 1;
+      setLostIOBitmap( fd );
     }
 }
 
 /* TCP_ASYNC */
 #endif
 
-
+#if defined( DISK_REPL )
+/* for crash simulation */
+SimulateCrashData swatAButterfly;
+/* DISK_REPL */
+#endif
 
 void
 comm_init(void)
@@ -850,9 +856,22 @@
      * Since Squid_MaxFD can be as high as several thousand, don't waste them */
     RESERVED_FD = XMIN(100, Squid_MaxFD / 4);
     CBDATA_INIT_TYPE(ConnectStateData);
-#ifdef TCP_ASYNC
+#if TCP_ASYNC
     our_pid = getpid();
 #endif
+    memset( syscallCallback, 0, sizeof syscallCallback );
+#if DISK_REPL
+    /* hard-coded */
+    swatAButterfly.swapDirNo = 0;
+    /* 20 seconds, ÐÏÌÅÔ ÎÏÒÍÁÌØÎÙÊ... */
+    swatAButterfly.crashTime = time( NULL ) + 20;
+#if SIMLUATE_READ_CRASH
+    addReadHook( simulateCrash, &swatAButterfly);
+#endif
+#if SIMULATE_WRITE_CRASH
+    addWriteHook( simulateCrash, &swatAButterfly);
+#endif
+#endif /* DISK_REPL */
     comm_write_pool = memPoolCreate("CommWriteStateData", sizeof(CommWriteStateData));
     conn_close_pool = memPoolCreate("close_handler", sizeof(close_handler));
 }
@@ -870,7 +889,7 @@
 	fd, (int) state->offset, state->size);
 
     nleft = state->size - state->offset;
-    len = write(fd, state->buf + state->offset, nleft);
+    len = comm_write_wrapper(fd, state->buf + state->offset, nleft);
     debug(5, 5) ("commHandleWrite: write() returns %d\n", len);
     fd_bytes(fd, len, FD_WRITE);
     statCounter.syscalls.sock.writes++;
@@ -890,7 +909,6 @@
 	} else if (ignoreErrno(errno)) {
 	    debug(50, 10) ("commHandleWrite: FD %d: write failure: %s.\n",
 		fd, xstrerror());
-	    CLEAR_CAN_WRITE( fd );
 	    commSetSelect(fd,
 		COMM_SELECT_WRITE,
 		commHandleWrite,
@@ -902,7 +920,6 @@
 	    CommWriteStateCallbackAndFree(fd, COMM_ERROR);
 	}
     } else {
-        CLEAR_CAN_WRITE_IF_FULL( nleft, len, fd );
 	/* A successful write, continue */
 	state->offset += len;
 	if (state->offset < state->size) {
@@ -954,6 +971,48 @@
     comm_write(fd, mb.buf, mb.size, handler, handler_data, memBufFreeFunc(&mb));
 }
 
+/* wrapper around syscall */
+int comm_read_wrapper( int fd, char *buf, int size )
+{
+  int ret;
+
+  assert( buf != NULL );
+  assert( size >= 0 );
+
+  ret = read( fd, buf, size );
+#if defined( TCP_ASYNC )
+  if( ( ( ret == -1 ) && ignoreErrno( errno ) ) ||
+      ( 0 && ( ret > 0 ) && ( ret < size ) ) )
+    {
+      CLEAR_CAN_READ( fd );
+    }
+/* TCP_ASYNC */
+#endif
+  callReadHook( fd, &errno );
+  return ret;
+}
+
+/* wrapper around syscall */
+int comm_write_wrapper( int fd, char *buf, int size )
+{
+  int ret;
+
+  assert( buf != NULL );
+  assert( size >= 0 );
+
+  ret = write( fd, buf, size );
+#if defined( TCP_ASYNC )
+  if( ( ( ret == -1 ) && ignoreErrno( errno ) ) ||
+      ( 0 && ( ret > 0 ) && ( ret < size ) ) )
+    {
+      CLEAR_CAN_WRITE( fd );
+    }
+/* TCP_ASYNC */
+#endif
+  callWriteHook( fd, &errno );
+  return ret;
+}
+
 /*
  * hm, this might be too general-purpose for all the places we'd
  * like to use it.
@@ -1005,3 +1064,103 @@
 	}
     }
 }
+
+/* syscall callbacks */
+#define SCB_DEBUG( format, args... )					\
+         debug( 5, 9 )( CURRENT_FUNCTION_NAME " (%s:%i): " format "\n",	\
+			__FILE__, __LINE__ , ##args )
+
+#define SCB_TRACE  SCB_DEBUG( "" )
+
+int addSyscallCB( SyscallCBInvoc *hook, SyscallCallBack cb, void *data )
+{
+  int i;
+
+  assert( hook != NULL );
+
+  SCB_TRACE;
+  for( i = 0 ; i < MAX_SYSCALLCB ; ++i )
+    {
+      if( hook[ i ].cb == NULL )
+	{
+	  hook[ i ].cb = cb;
+	  hook[ i ].data = data;
+	  return 1;
+	}
+    }
+  return 0;
+}
+
+int delSyscallCB( SyscallCBInvoc *hook, SyscallCallBack cb )
+{
+  int i;
+
+  assert( hook != NULL );
+
+  SCB_TRACE;
+  for( i = 0 ; i < MAX_SYSCALLCB ; ++i )
+    {
+      if( hook[ i ].cb == cb )
+	{
+	  hook[ i ].cb = NULL;
+	  hook[ i ].data = NULL;
+	  return 1;
+	}
+    }
+  return 0;
+}
+
+int addReadHook( SyscallCallBack cb, void *data )
+{
+  SCB_TRACE;
+  return addSyscallCB( syscallCallback[ SYSCALL_READ ], cb, data );
+}
+
+int addWriteHook( SyscallCallBack cb, void *data )
+{
+  SCB_TRACE;
+  return addSyscallCB( syscallCallback[ SYSCALL_WRITE ], cb, data );
+}
+
+syscallcb_result callSyscallCBHook( SyscallCBInvoc *hook, 
+				    syscall_type call,
+				    int fd, int *errNo )
+{
+  assert( hook != NULL );
+  
+  SCB_TRACE;
+  for( ; hook -> cb != NULL ; ++hook )
+    {
+      syscallcb_result result;
+
+      result = ( hook -> cb )( call, fd, errNo, hook -> data );
+      if( result == SYSCALLCB_ABORT )
+	{
+	  return SYSCALLCB_ABORT;
+	}
+    }
+  return SYSCALLCB_CONTINUE;
+}
+
+syscallcb_result callReadHook( int fd, int *errNo )
+{
+  SCB_TRACE;
+  return callSyscallCBHook( syscallCallback[ SYSCALL_READ ], 
+			    SYSCALL_READ, fd, errNo );
+}
+
+syscallcb_result callWriteHook( int fd, int *errNo )
+{
+  SCB_TRACE;
+  return callSyscallCBHook( syscallCallback[ SYSCALL_WRITE ], 
+			    SYSCALL_WRITE, fd, errNo );
+}
+
+syscallcb_result echoSyscallCB( syscall_type call,
+				int fd, int *errNo,
+				void *data )
+{
+  SCB_DEBUG( "call: %i fd: %i errno: %i data: %p", call, fd, *errNo, data );
+  return SYSCALLCB_CONTINUE;
+}
+
Index: squid/src/comm_cio.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/comm_cio.c,v
retrieving revision 1.1.2.1
retrieving revision 1.1.2.1.2.1
diff -u -r1.1.2.1 -r1.1.2.1.2.1
--- squid/src/comm_cio.c	17 Dec 2000 14:09:08 -0000	1.1.2.1
+++ squid/src/comm_cio.c	17 Dec 2000 14:36:23 -0000	1.1.2.1.2.1
@@ -1,5 +1,5 @@
 /*
- * $Id: comm_cio.c,v 1.1.2.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: comm_cio.c,v 1.1.2.1.2.1 2000/12/17 14:36:23 hno Exp $
  *
  * DEBUG: section 90     Signal-driven network IO
  * AUTHOR: Nikita Danilov <NikitaDanilov@Yahoo.COM>
@@ -136,9 +136,6 @@
 
 #include <linux/reiserfs_fs.h>
 
-/** if we use ioctl in stead of sigtimedwait, ioctl_fd is descriptor
-	of reiserfs directory on which ioctl is issued. */
-static int ioctl_fd = -1;
 /* SIGRTMAX is not constant?! */
 /** global array of per-signal-number callbacks */
 static CioCallback callbacks[ _NSIG ];
@@ -153,6 +150,61 @@
 	handlers, taking deferred reads into account */
 extern int cioStdCallback( siginfo_t *info );
 
+#if defined( __GNUC__ )
+#define BITMAP_TYPE   long long
+#define BITMAP_BIT    1LL
+#else
+#define BITMAP_TYPE   long
+#define BITMAP_BIT    1L
+#endif
+
+static BITMAP_TYPE *lostIOBitmap;
+
+#define INDEX_IN_BITMAP( offset ) ( offset / sizeof lostIOBitmap[ 0 ] )
+#define OFFSET_IN_BYTE( offset ) ( offset % sizeof lostIOBitmap[ 0 ] )
+
+#define MASK_IN_BITMAP( offset ) ( BITMAP_BIT << OFFSET_IN_BYTE( offset ) )
+#define SET_BIT_IN_BITMAP( offset ) \
+   lostIOBitmap[ INDEX_IN_BITMAP( offset ) ] |= MASK_IN_BITMAP( offset )
+
+#define CLN_BIT_IN_BITMAP( offset ) \
+   lostIOBitmap[ INDEX_IN_BITMAP( offset ) ] &= ~MASK_IN_BITMAP( offset )
+
+
+#if defined( CIOCIOSAN_USE_SIGHANDLER )
+
+#include <asm/atomic.h>
+#include <signal.h>
+
+#define SIGINFOS_IN_QUEUE ( 1024 + 42 ) /* XXX just some arbitrary number */
+static volatile struct CioSiginfoQueue {
+  /* 
+	 XXX sig_atomic_t is only guaranteed to work correctly 
+	 on the uniprocessor. Hence I will use atomic_t in it stead.
+  */
+  volatile atomic_t count;
+  volatile siginfo_t info[ SIGINFOS_IN_QUEUE ]; 
+} queue;
+
+static void cioSigHandler( int sigNum, siginfo_t *info, void *data )
+{
+  if( atomic_read( &queue.count ) < SIGINFOS_IN_QUEUE )
+	{
+	  memcpy( ( void * )&queue.info[ atomic_read( &queue.count ) ], info, 
+			  sizeof *info );
+	  atomic_inc( ( atomic_t * )&queue.count );
+	}
+}
+
+#else
+
+/** if we use ioctl in stead of sigtimedwait, ioctl_fd is descriptor
+	of reiserfs directory on which ioctl is issued. */
+static int ioctl_fd = -1;
+
+/* CIOCIOSAN_USE_SIGHANDLER */
+#endif
+
 /** call this to register your own callback. SIG_NUM will be blocked
 	by this call. */
 int commCioAddCB( int sig_num, CioCallback callback )
@@ -160,10 +212,21 @@
   TRACE;
   if( callbacks[ sig_num ] == NULL )
     {
-      callbacks[ sig_num ] = callback;
+#if !defined( CIOCIOSAN_USE_SIGHANDLER )
       sigaddset( &listenOn, sig_num );
       sigprocmask( SIG_BLOCK, &listenOn, NULL );
-  
+#else
+	  struct sigaction act;
+
+	  act.sa_sigaction = cioSigHandler;
+	  act.sa_flags = SA_SIGINFO;
+	  if( sigaction( sig_num, &act, NULL ) == -1 )
+		{
+		  DEBUG( "commCioAddCB: sigaction( %i ) fails: %s\n",
+				 sig_num, xstrerror() );
+		}
+#endif  
+      callbacks[ sig_num ] = callback;
       return 1;
     }
   else
@@ -175,12 +238,13 @@
 /** initialize Cio Cio San */
 int initCommCio()
 {
+#if !defined( CIOCIOSAN_USE_SIGHANDLER )
   int i;
 
   /* scan all configured cache dirs to find butterfly.  We need
 	 butterfly as it always works on top of a reiserfs directory and
 	 we need one reiserfs directory to use our magic ioctl. */
-  for( i = 0 ; i < Config.cacheSwap.n_configured ; i++ )
+  FOREACHSDINDEX( i )
 	{
 	  SwapDir *sd;
 	  
@@ -198,34 +262,72 @@
 	  ioctl_fd = open( "/cache", O_RDONLY );
 	}
 
-  if( ioctl_fd > 0 )
-	{
-	  /* prepare global data structures */
-	  memset( callbacks, 0, sizeof callbacks );
-	  sigemptyset( &listenOn );
-
-	  statCounter.syscalls.async.signals = 0;
-	  statCounter.syscalls.async.read_sigs = 0;
-	  statCounter.syscalls.async.write_sigs = 0;
-	  statCounter.syscalls.async.loops = 0;
-	  statCounter.syscalls.async.avg_ready_read = 0.0;
-	  statCounter.syscalls.async.avg_ready_write = 0.0;
-	  statCounter.syscalls.async.tail_reads = 0;
-	  statCounter.syscalls.async.tail_writes = 0;
-	  statCounter.syscalls.async.drain_reads = 0;
-	  statCounter.syscalls.async.drain_writes = 0;
-
-	  TRACE;
-	  commCioAddCB( SIGCIOCIOSAN, cioStdCallback );
-	  return 1;
-	}
-  else
+  if( ioctl_fd < 0 )
 	{
 	  /* will use normal sigtimedwait */
 	  DEBUG( "initCommCio: Keine butterfly cache_dir gefunden."
 			 " Cio Cio San will use sigtimedwait(2).\n" );
 	  return 0;
 	}
+#else
+  DEBUG( "initCommCio: will use notification through signal handler\n" );
+
+  atomic_set( &queue.count, 0 );
+  memset( ( void * ) queue.info, 0, sizeof queue.info );
+
+/* CIOCIOSAN_USE_SIGHANDLER */
+#endif
+  /* prepare global data structures */
+  memset( callbacks, 0, sizeof callbacks );
+  sigemptyset( &listenOn );
+  statCounter.syscalls.async.signals = 0;
+  statCounter.syscalls.async.read_sigs = 0;
+  statCounter.syscalls.async.write_sigs = 0;
+  statCounter.syscalls.async.loops = 0;
+  statCounter.syscalls.async.avg_ready_read = 0.0;
+  statCounter.syscalls.async.avg_ready_write = 0.0;
+  statCounter.syscalls.async.tail_reads = 0;
+  statCounter.syscalls.async.tail_writes = 0;
+  statCounter.syscalls.async.drain_reads = 0;
+  statCounter.syscalls.async.drain_writes = 0;
+  
+  lostIOBitmap = 
+	xcalloc( Biggest_FD / sizeof lostIOBitmap[ 0 ] / 8 + 1,
+			 sizeof lostIOBitmap[ 0 ] );
+  commCioAddCB( SIGCIOCIOSAN, cioStdCallback );
+  return 1;
+}
+
+static void processOneSiginfo( siginfo_t *info )
+{
+  if( callbacks[ info -> si_signo ] != NULL )
+	{
+	  if( fd_table[ info -> si_fd ].flags.async_tcp )
+		{
+		  TRACE0( "callback: fd: %i, signo: %i", 
+				  info -> si_fd, info -> si_signo );
+		  callbacks[ info -> si_signo ]( info );
+		  ++statCounter.syscalls.async.signals;
+		}
+	  else if( !fd_table[ info -> si_fd ].flags.open )
+		{
+		  DEBUG
+			( "commCioLoop: got signal: %i for already closed fd: %i\n", 
+			  info -> si_signo, info -> si_fd );
+		}
+	  else
+		{
+		  DEBUG
+			( "commCioLoop: got unexpected signal: %i for fd: %i\n", 
+			  info -> si_signo, info -> si_fd );
+		}
+	}
+  else
+	{
+	  DEBUG
+		( "commCioLoop: got unexpected signal: %i\n", 
+		  info -> si_signo );
+	}
 }
 
 /* main signal polling loop. Uses either ioctl( REISERFS_IOC_TIMEDWAIT )
@@ -233,11 +335,12 @@
    signals received. Sets can_* flags in fds. */   
 int commCioLoop()
 {
+  int ranOnce;
+#if !defined( CIOCIOSAN_USE_SIGHANDLER )
   struct reiserfs_sigtimedwait_arg arg;
   siginfo_t siginfo[ SIGINFO_PER_CALL ];
-  struct timespec timeout = {0,0};
+  struct timespec timeout = { 0, 0 };
   int numOfSigs;
-  int ranOnce;
 
   arg.uthese = &listenOn;
   arg.sigsetsize = 8; /* sizeof mask; */
@@ -262,37 +365,7 @@
 	  ranOnce = 1;
       for( i = 0 ; i < numOfSigs ; ++i )
 		{
-		  siginfo_t *info;
-
-		  info = &siginfo[ i ];
-		  if( callbacks[ info -> si_signo ] != NULL )
-			{
-			  if( fd_table[ info -> si_fd ].flags.async_tcp )
-				{
-				  TRACE0( "callback: fd: %i, signo: %i", 
-						  info -> si_fd, info -> si_signo );
-				  callbacks[ info -> si_signo ]( info );
-				  ++statCounter.syscalls.async.signals;
-				}
-			  else if( !fd_table[ info -> si_fd ].flags.open )
-				{
-				  DEBUG
-					( "commCioLoop: got signal: %i for already closed fd: %i\n", 
-					  info -> si_signo, info -> si_fd );
-				}
-			  else
-				{
-				  DEBUG
-					( "commCioLoop: got unexpected signal: %i for fd: %i\n", 
-					  info -> si_signo, info -> si_fd );
-				}
-			}
-		  else
-			{
-			  DEBUG
-				( "commCioLoop: got unexpected signal: %i\n", 
-				  info -> si_signo );
-			}
+		  processOneSiginfo( &siginfo[ i ] );
 		}
     }
   if( ranOnce )
@@ -315,6 +388,33 @@
 		  return COMM_ERROR;
 		}
 	}
+/* CIOCIOSAN_USE_SIGHANDLER */
+#else
+  ranOnce = 0;
+  if( atomic_read( &queue.count ) >= SIGINFOS_IN_QUEUE )
+	{
+	  debug( 90, 1 ) ( "commCioLoop: queue overrun.\n" );
+	  atomic_dec( ( atomic_t * ) &queue.count );
+	}
+  else while( atomic_read( &queue.count ) > 0 )
+	{
+	  /* blammm, handler breaks in here, but it only increases count, ok */
+	  siginfo_t info;
+	  ranOnce = 1;
+	  /* blammm, handler breaks in during memcpy, ok */
+	  assert( ( atomic_read( &queue.count ) > 0 ) &&
+			  ( atomic_read( &queue.count ) < SIGINFOS_IN_QUEUE ) );
+	  memcpy 
+		( &info, ( void * ) &queue.info[ atomic_read( &queue.count ) - 1 ], 
+		  sizeof info );
+	  /* blammm, handler breaks in here, increases count, ok */
+	  atomic_dec( ( atomic_t * ) &queue.count );
+	  /* blammm, handler breaks in here, increases count, ok */
+	  processOneSiginfo( &info );
+	}
+  return ranOnce ? COMM_OK : COMM_TIMEOUT;
+/* CIOCIOSAN_USE_SIGHANDLER */
+#endif
 }
 
 /* taken from comm_select.c */
@@ -336,7 +436,7 @@
    ,,special processing`` means we have to call callbacks with special
    parameters (ask someone else why) */
 
-static int fdIsHttp( int fd )
+static inline int fdIsHttp( int fd )
 {
   int j;
 
@@ -350,31 +450,57 @@
   return 0;
 }
 
-static int fdIsIcp( int fd )
+static inline int fdIsIcp( int fd )
 {
-  if( fd == theInIcpConnection )
-	{
-	  return 1;
-	}
-  if( fd == theOutIcpConnection )
-	{
-	  return 1;
-	}
-  return 0;
+  return( ( fd == theInIcpConnection ) || ( fd == theOutIcpConnection ) );
+}
+
+static inline int fdIsDns( int fd )
+{
+  return( fd == DnsSocket );
 }
 
-static int fdIsDns( int fd )
+static int inline isDatalessSocket( int fd )
 {
-  if( fd == DnsSocket )
+  return( fdIsHttp( fd ) || fdIsIcp( fd ) || fdIsDns( fd ) );
+}
+
+static inline void cioProcessReadFD( int index )
+{
+  fde *F;
+  PF *handler;
+  int dummy;
+
+  assert( ( 0 <= index ) && ( index <= Biggest_FD ) );
+  assert( fd_table[ index ].flags.can_read );
+
+  F = &fd_table[ index ];
+  DEBUG( "cioProcessReadFD: FD %d lost read", index );
+  if( !commCioDeferRead( index ) && 
+	  ( ( handler = F -> read_handler ) != NULL ) )
 	{
-	  return 1;
+	  F -> read_handler = NULL;
+	  handler( index, isDatalessSocket( index ) ? &dummy : F -> read_data );
 	}
-  return 0;
 }
 
-int isDatalessSocket( int fd )
+static inline void cioProcessWriteFD( int index )
 {
-  return( fdIsHttp( fd ) || fdIsIcp( fd ) || fdIsDns( fd ) );
+  fde *F;
+  PF *handler;
+  int dummy;
+
+  assert( ( 0 <= index ) && ( index <= Biggest_FD ) );
+  assert( fd_table[ index ].flags.can_write );
+
+  F = &fd_table[ index ];
+
+  DEBUG( "cioProcessWriteFD: FD %d lost write", index );
+  if( ( handler = F -> write_handler ) != NULL )
+	{
+	  F -> write_handler = NULL;
+	  handler( index, isDatalessSocket( index ) ? &dummy : F -> write_data );
+	}
 }
 
 /* see description in declaration */
@@ -390,18 +516,21 @@
   assert( fd >= 0 );
   assert( f -> flags.open );
 
+  SET_BIT_IN_BITMAP( fd );
   result = 0;
   if( info -> si_band & ( POLLRDNORM | POLLIN | POLLHUP | POLLERR ) )
 	{
 	  /* non-blocking read is possible */
 	  fd_table[ fd ].flags.can_read = 1;
 	  ++statCounter.syscalls.async.read_sigs;
+	  cioProcessReadFD( fd );
 	}
   if( info -> si_band & ( POLLWRNORM | POLLOUT | POLLHUP | POLLERR ) )
 	{
 	  /* non-blocking write is possible */
 	  fd_table[ fd ].flags.can_write = 1;
 	  ++statCounter.syscalls.async.write_sigs;
+	  cioProcessWriteFD( fd );
 	}
   /* Just sanity check. */
   if( ( !( info -> si_band & 
@@ -449,9 +578,16 @@
   for( i = 0 ; i <= Biggest_FD ; i++ )
 	{
 	  fde *F;
-	  int dummy;
-	  PF *handler;
-	  int  incoming;
+
+	  /* run through bitmap */
+	  for( ; 
+		   lostIOBitmap[ INDEX_IN_BITMAP( i ) ] == 0 ; 
+		   i += sizeof lostIOBitmap[ 0 ] )
+		{}
+	  if( i > Biggest_FD )
+		{
+		  break;
+		}
 
 	  F = &fd_table[ i ];
 
@@ -467,28 +603,15 @@
 		{
 		  /* is this is socket listening for incoming HTTP connections or
 			 DNS socket etc.? */
-		  incoming = -1;
-		  if( F -> flags.can_read && ( handler = F -> read_handler ) )
+		  if( F -> flags.can_read )
 			{
 			  ++readReady;
-			  incoming = isDatalessSocket( i );
-			  DEBUG( "cioCatchLostIO: FD %d lost read", i );
-			  if( !commCioDeferRead( i ) )
-				{
-				  F -> read_handler = NULL;
-				  handler( i, incoming ? &dummy : F -> read_data );
-				}
+			  cioProcessReadFD( i );
 			}
-		  if( F -> flags.can_write && ( handler = F -> write_handler ) )
+		  if( F -> flags.can_write )
 			{
 			  ++writeReady;
-			  if( incoming == -1 )
-				{
-				  incoming = isDatalessSocket( i );
-				}
-			  DEBUG( "cioCatchLostIO: FD %d lost write", i );
-			  F -> write_handler = NULL;
-			  handler( i, incoming ? &dummy : F -> write_data );
+			  cioProcessWriteFD( i );
 			}
 		}
 	}
@@ -505,6 +628,16 @@
   return 1;
 }
 
+void clearLostIOBitmap( int fd )
+{
+  CLN_BIT_IN_BITMAP( fd );
+}
+
+void setLostIOBitmap( int fd )
+{
+  SET_BIT_IN_BITMAP( fd );
+}
+
 /* TCP_ASYNC */
 #endif
 
@@ -515,6 +648,9 @@
 
 /*
  * $Log: comm_cio.c,v $
+ * Revision 1.1.2.1.2.1  2000/12/17 14:36:23  hno
+ * Imported raid from squidng
+ *
  * Revision 1.1.2.1  2000/12/17 14:09:08  hno
  * Imported tcp_async from squidng
  *
Index: squid/src/defines.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/defines.h,v
retrieving revision 1.3.16.1.2.1
retrieving revision 1.3.16.1.2.1.4.1
diff -u -r1.3.16.1.2.1 -r1.3.16.1.2.1.4.1
--- squid/src/defines.h	17 Dec 2000 13:55:39 -0000	1.3.16.1.2.1
+++ squid/src/defines.h	17 Dec 2000 14:36:23 -0000	1.3.16.1.2.1.4.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: defines.h,v 1.3.16.1.2.1 2000/12/17 13:55:39 hno Exp $
+ * $Id: defines.h,v 1.3.16.1.2.1.4.1 2000/12/17 14:36:23 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -287,3 +287,92 @@
 #define CBDATA_TYPE(type)	static cbdata_type CBDATA_##type = 0
 #define CBDATA_INIT_TYPE(type)	(CBDATA_##type = cbdataAddType(CBDATA_##type, #type, sizeof(type)))
 
+/* cio cio san */
+#if defined( TCP_ASYNC )
+
+/* It's Butterfly's real name */
+#define SIGCIOCIOSAN ( SIGRTMIN + 8 )
+
+#define SIGINFO_PER_CALL 128
+
+#if defined( __GNUC__ )
+#define CURRENT_FUNCTION_NAME __PRETTY_FUNCTION__
+#else
+#define CURRENT_FUNCTION_NAME __FUNC__
+#endif
+
+#define CLEAR_CAN_READ_INTERNAL( fd )									\
+	  debug( 90, 9 )( CURRENT_FUNCTION_NAME ": cleared can_read.\n" );	\
+	  fd_table[ fd ].flags.can_read = 0;								\
+      if( !fd_table[ fd ].flags.can_write ) clearLostIOBitmap( fd )
+
+#define CLEAR_CAN_WRITE_INTERNAL( fd )									\
+	  debug( 90, 9 )( CURRENT_FUNCTION_NAME ": cleared can_write.\n" );	\
+	  fd_table[ fd ].flags.can_write = 0;								\
+      if( !fd_table[ fd ].flags.can_read ) clearLostIOBitmap( fd )
+
+#define CLEAR_CAN_READ( fd ) do {							\
+      CLEAR_CAN_READ_INTERNAL( fd );						\
+      ++statCounter.syscalls.async.tail_reads; } while( 0 )
+
+#define CLEAR_CAN_WRITE( fd ) do {								\
+      CLEAR_CAN_WRITE_INTERNAL( fd );							\
+      ++statCounter.syscalls.async.tail_writes; } while( 0 )
+
+#define CLEAR_CAN_READ_IF_EMPTY( requestedSize, actuallyRead, fd )		\
+  do																	\
+    {																	\
+	  if( ( actuallyRead > 0 ) && ( actuallyRead < requestedSize ) )	\
+		{																\
+		  /* CLEAR_CAN_READ_INTERNAL( fd ); */							\
+          ++statCounter.syscalls.async.drain_reads;						\
+		}																\
+	}																	\
+  while( 0 )
+
+#define CLEAR_CAN_WRITE_IF_FULL( requestedSize, actuallyWritten, fd )		\
+  do																		\
+    {																		\
+	  if( ( actuallyWritten > 0 ) && ( actuallyWritten < requestedSize ) )	\
+		{																	\
+		  /* CLEAR_CAN_WRITE_INTERNAL( fd ); */								\
+          ++statCounter.syscalls.async.drain_writes;						\
+		}																	\
+	}																		\
+  while( 0 )
+
+/* !TCP_ASYNC */
+#else
+
+#define CLEAR_CAN_READ( fd )  do {} while( 0 )
+#define CLEAR_CAN_WRITE( fd ) do {} while( 0 )
+#define CLEAR_CAN_READ_IF_EMPTY( requestedSize, actuallyRead, fd ) \
+  do {} while( 0 )
+#define CLEAR_CAN_WRITE_IF_FULL( requestedSize, actuallyWritten, fd )	\
+  do {} while( 0 )
+
+/* TCP_ASYNC */
+#endif
+
+#if defined( DISK_REPL )
+
+/* errno returned if drive dies */
+#define DISK_DIES_ERRNO    EIO /* ENXIO */
+/* how many DISK_DIES_ERRNOs tolerate before declaring drive dead */
+#define ERRORS_THRESHOLD   2
+
+#define RAID_CTRL_SIG SIGRTMIN + 9
+
+/* RAID_REPL */
+#endif
+
+/* how many global syscall callbacks can be registered */
+#define MAX_SYSCALLCB   128
+
+#define FOREACHSDINDEX( var ) \
+           for( var = 0 ; var < Config.cacheSwap.n_configured ; ++var )
+
+#define FOREACHSD( var ) \
+           for( var = INDEXSD( 0 ) ; \
+                var < INDEXSD( Config.cacheSwap.n_configured ) ; ++var )
+
